--[[
global.transformer <- list of transformers

transformer:
	trafo     -- the transformer itself
	producer  -- the power producing part
	consumer  -- the power consuming part
	direction -- direction when first placed

	accumulator
	
all local functions are prefixed with "transformer"
	
--]]




--[[

script.on_init(function()
   if global.TickerA == nil then
      global.TickerA = 59
   end
   if global.TickerB == nil then
      global.TickerB = 5
   end

end)

script.on_load(function()
   if global.TickerA == nil then
      global.TickerA = 59
   end
   if global.TickerB == nil then
      global.TickerB = 5
   end
end)
--]]


--
script.on_init(function()
	if global.transformer_s == nil then
		global.transformer_s = {}
	end
	if global.transformer_m == nil then
		global.transformer_m = {}
	end
	if global.transformer_l == nil then
		global.transformer_l = {}
	end
	if global.transformer_xl == nil then
		global.transformer_xl = {}
	end
end)

script.on_load(function()
	if global.transformer_s == nil then
		global.transformer_s = {}
	end
	if global.transformer_m == nil then
		global.transformer_m = {}
	end
	if global.transformer_l == nil then
		global.transformer_l = {}
	end
	if global.transformer_xl == nil then
		global.transformer_xl = {}
	end
end)




-- Make sure our functions get called for specific events.
-- A robot built one.
script.on_event(defines.events.on_robot_built_entity, function(event) OnBuilt(event.created_entity) end)
-- A player built one.
script.on_event(defines.events.on_built_entity, function(event) OnBuilt(event.created_entity) end)

-- A player removed one.
script.on_event(defines.events.on_preplayer_mined_item, function(event) OnRemoved(event.entity) end)
-- A robot removed one.
script.on_event(defines.events.on_robot_pre_mined, function(event) OnRemoved(event.entity) end)
-- It died.
script.on_event(defines.events.on_entity_died, function(event) OnRemoved(event.entity) end)

local function transformerIstransformer(entity)
	if entity.name == "transformer-s" then
		return true
	elseif entity.name == "transformer-m" then
		return true
	elseif entity.name == "transformer-l" then
		return true
	elseif entity.name == "transformer-xl" then
		return true
	else
		return false
	end
end

local function transformerGetSourcePosition(direction)
	if direction == 0 then		return {x = 0, y = 1}   -- north
	elseif direction == 2 then	return {x = -1, y = 0}  -- ost
	elseif direction == 4 then	return {x = 0, y = -1}  -- south
	else						return {x = 1, y = 0}   -- west
	end
end

local function transformerGetTargetPosition(direction)
	if direction == 0 then		return {x = 0, y = -1}   -- north
	elseif direction == 2 then	return {x = 1, y = 00}  -- ost
	elseif direction == 4 then	return {x = 0, y = 1}  -- south
	else						return {x = -1, y = 0}   -- west
	end
end
function OnBuilt(entity)
      --game.createentity{name = "pole-light", position = entity.position, force = entity.force}
	if transformerIstransformer(entity) then
		
		if entity.name == "transformer-s" then
		
		local struct = {trafo = entity}
		struct.direction = entity.direction
		local srcpos = transformerGetSourcePosition(struct.direction)
		local tarpos = transformerGetTargetPosition(struct.direction)
		local srcconpos = {x = srcpos.x, y = srcpos.y}
		local tarconpos = {x = tarpos.x, y = tarpos.y}
		srcconpos.x = 2 * srcconpos.x + entity.position.x
		srcconpos.y = 2 * srcconpos.y + entity.position.y
		tarconpos.x = 2 * tarconpos.x + entity.position.x
		tarconpos.y = 2 * tarconpos.y + entity.position.y
		srcpos.x = srcpos.x + entity.position.x
		srcpos.y = srcpos.y + entity.position.y
		tarpos.x = tarpos.x + entity.position.x
		tarpos.y = tarpos.y + entity.position.y
		
		local create = entity.surface.create_entity
		local producer = create{name = "powerproducer-s", position =
			tarpos, force = entity.force}
		struct.producer = producer
		local consumer = create{name = "powerconsumer-s", position =
			srcpos, force = entity.force}
		struct.consumer = consumer
		local consumer_pole = create{name = "transformer-connection".."_src_"..entity.direction,
			position = srcconpos, force = entity.force}
		struct.consumer_pole = consumer_pole
		local producer_pole = create{name = "transformer-connection".."_tar_"..entity.direction,
			position = tarconpos, force = entity.force}
		struct.producer_pole = producer_pole
		struct.lastdraw = 0
		
		table.insert(global.transformer_s, struct)
		end
		
		if entity.name == "transformer-m" then
		
		local struct = {trafo = entity}
		struct.direction = entity.direction
		local srcpos = transformerGetSourcePosition(struct.direction)
		local tarpos = transformerGetTargetPosition(struct.direction)
		local srcconpos = {x = srcpos.x, y = srcpos.y}
		local tarconpos = {x = tarpos.x, y = tarpos.y}
		srcconpos.x = 2 * srcconpos.x + entity.position.x
		srcconpos.y = 2 * srcconpos.y + entity.position.y
		tarconpos.x = 2 * tarconpos.x + entity.position.x
		tarconpos.y = 2 * tarconpos.y + entity.position.y
		srcpos.x = srcpos.x + entity.position.x
		srcpos.y = srcpos.y + entity.position.y
		tarpos.x = tarpos.x + entity.position.x
		tarpos.y = tarpos.y + entity.position.y
		
		local create = entity.surface.create_entity
		local producer = create{name = "powerproducer-m", position =
			tarpos, force = entity.force}
		struct.producer = producer
		local consumer = create{name = "powerconsumer-m", position =
			srcpos, force = entity.force}
		struct.consumer = consumer
		local consumer_pole = create{name = "transformer-connection".."_src_"..entity.direction,
			position = srcconpos, force = entity.force}
		struct.consumer_pole = consumer_pole
		local producer_pole = create{name = "transformer-connection".."_tar_"..entity.direction,
			position = tarconpos, force = entity.force}
		struct.producer_pole = producer_pole
		struct.lastdraw = 0
		
		table.insert(global.transformer_m, struct)
		end
		
		if entity.name == "transformer-l" then
		
		local struct = {trafo = entity}
		struct.direction = entity.direction
		local srcpos = transformerGetSourcePosition(struct.direction)
		local tarpos = transformerGetTargetPosition(struct.direction)
		local srcconpos = {x = srcpos.x, y = srcpos.y}
		local tarconpos = {x = tarpos.x, y = tarpos.y}
		srcconpos.x = 2 * srcconpos.x + entity.position.x
		srcconpos.y = 2 * srcconpos.y + entity.position.y
		tarconpos.x = 2 * tarconpos.x + entity.position.x
		tarconpos.y = 2 * tarconpos.y + entity.position.y
		srcpos.x = srcpos.x + entity.position.x
		srcpos.y = srcpos.y + entity.position.y
		tarpos.x = tarpos.x + entity.position.x
		tarpos.y = tarpos.y + entity.position.y
		
		local create = entity.surface.create_entity
		local producer = create{name = "powerproducer-l", position =
			tarpos, force = entity.force}
		struct.producer = producer
		local consumer = create{name = "powerconsumer-l", position =
			srcpos, force = entity.force}
		struct.consumer = consumer
		local consumer_pole = create{name = "transformer-connection".."_src_"..entity.direction,
			position = srcconpos, force = entity.force}
		struct.consumer_pole = consumer_pole
		local producer_pole = create{name = "transformer-connection".."_tar_"..entity.direction,
			position = tarconpos, force = entity.force}
		struct.producer_pole = producer_pole
		struct.lastdraw = 0
		
		table.insert(global.transformer_l, struct)
		end
		
		if entity.name == "transformer-xl" then
		
		local struct = {trafo = entity}
		struct.direction = entity.direction
		local srcpos = transformerGetSourcePosition(struct.direction)
		local tarpos = transformerGetTargetPosition(struct.direction)
		local srcconpos = {x = srcpos.x, y = srcpos.y}
		local tarconpos = {x = tarpos.x, y = tarpos.y}
		srcconpos.x = 2 * srcconpos.x + entity.position.x
		srcconpos.y = 2 * srcconpos.y + entity.position.y
		tarconpos.x = 2 * tarconpos.x + entity.position.x
		tarconpos.y = 2 * tarconpos.y + entity.position.y
		srcpos.x = srcpos.x + entity.position.x
		srcpos.y = srcpos.y + entity.position.y
		tarpos.x = tarpos.x + entity.position.x
		tarpos.y = tarpos.y + entity.position.y
		
		local create = entity.surface.create_entity
		local producer = create{name = "powerproducer-xl", position =
			tarpos, force = entity.force}
		struct.producer = producer
		local consumer = create{name = "powerconsumer-xl", position =
			srcpos, force = entity.force}
		struct.consumer = consumer
		local consumer_pole = create{name = "transformer-connection".."_src_"..entity.direction,
			position = srcconpos, force = entity.force}
		struct.consumer_pole = consumer_pole
		local producer_pole = create{name = "transformer-connection".."_tar_"..entity.direction,
			position = tarconpos, force = entity.force}
		struct.producer_pole = producer_pole
		struct.lastdraw = 0
		
		table.insert(global.transformer_xl, struct)
		end
		
		
	end
end

function OnRemoved(entity)
	if transformerIstransformer(entity) then
		local found_struct
		local index
		
		if entity.name == "transformer-s" then
		
		for key, struct in pairs(global.transformer_s) do
			if struct.trafo == entity then
				found_struct = struct
				index = key
				break
			end
		end
		table.remove(global.transformer_s, index)
		found_struct.producer.destroy()
		found_struct.producer = nil
		found_struct.consumer.destroy()
		found_struct.consumer = nil
		found_struct.producer_pole.destroy()
		found_struct.producer_pole = nil
		found_struct.consumer_pole.destroy()
		found_struct.consumer_pole = nil
		
		end
		
		if entity.name == "transformer-m" then
		
		for key, struct in pairs(global.transformer_m) do
			if struct.trafo == entity then
				found_struct = struct
				index = key
				break
			end
		end
		table.remove(global.transformer_m, index)
		found_struct.producer.destroy()
		found_struct.producer = nil
		found_struct.consumer.destroy()
		found_struct.consumer = nil
		found_struct.producer_pole.destroy()
		found_struct.producer_pole = nil
		found_struct.consumer_pole.destroy()
		found_struct.consumer_pole = nil
		
		end
		
		if entity.name == "transformer-l" then
		
		for key, struct in pairs(global.transformer_l) do
			if struct.trafo == entity then
				found_struct = struct
				index = key
				break
			end
		end
		table.remove(global.transformer_l, index)
		found_struct.producer.destroy()
		found_struct.producer = nil
		found_struct.consumer.destroy()
		found_struct.consumer = nil
		found_struct.producer_pole.destroy()
		found_struct.producer_pole = nil
		found_struct.consumer_pole.destroy()
		found_struct.consumer_pole = nil
		
		end
		
		if entity.name == "transformer-xl" then
		
		for key, struct in pairs(global.transformer_xl) do
			if struct.trafo == entity then
				found_struct = struct
				index = key
				break
			end
		end
		table.remove(global.transformer_xl, index)
		found_struct.producer.destroy()
		found_struct.producer = nil
		found_struct.consumer.destroy()
		found_struct.consumer = nil
		found_struct.producer_pole.destroy()
		found_struct.producer_pole = nil
		found_struct.consumer_pole.destroy()
		found_struct.consumer_pole = nil
		
		end
		
	end
end



script.on_event(defines.events.on_player_rotated_entity, function(event)
	local entity = event.entity;
	if transformerIstransformer(entity) then
		
		if entity.name == "transformer-s" then
		
		for key, struct in pairs(global.transformer_s) do
			if struct.trafo == entity then
				entity.direction = struct.direction
				break
			end
		end
		
		end
		
		if entity.name == "transformer-m" then
		
		for key, struct in pairs(global.transformer_m) do
			if struct.trafo == entity then
				entity.direction = struct.direction
				break
			end
		end
		
		end
		
		if entity.name == "transformer-l" then
		
		for key, struct in pairs(global.transformer_l) do
			if struct.trafo == entity then
				entity.direction = struct.direction
				break
			end
		end
		
		end
		
		if entity.name == "transformer-xl" then
		
		for key, struct in pairs(global.transformer_xl) do
			if struct.trafo == entity then
				entity.direction = struct.direction
				break
			end
		end
		
		end
		
	end
end)


--------------------------------------------------



script.on_event(defines.events.on_tick, function(event)
	
	
	exchanger_s()
	
	exchanger_m()
	
	exchanger_l()
	
	exchanger_xl()
	
	
end)	


-- consumer 
	--[[
		100 unit=6kw [calculated every tick]  
		100 unit * 60ticks = 6kj
		100 unit = 6/60 kj/tick =1/10 kj [energy in every tick]
		1000 unit = 1kj/tick
		concluison>> if consumer consumes 1000 (in one tick),it is equivilent to 1kj energy
	--]]
	-- producer (at 1 efficiency)(10 degree temperature difference)
	--[[
		1 unit(liquid\lq)=600kw [calculated every tick]  
		1 unit * 60ticks = 600kj
		1 unit = 600/60 kj/tick =10 kj [energy in every tick]
		1 unit = 10kj/tick
		concluison>> if producer consumes 1 (in one tick),it is equivilent to 10kj energy
	--]]
	
	--for same energy,producer.unit = consumer.unit/1e4			(1e4=10000) 
	
	
	
	-- there is an additional energy (160MJ) transfer due to initial sudden jerk
	
	
	
function exchanger_s()
	if global.transformer_s ~= nil then
	
	local eff = 1e2		-- producer efficiency
	local efficiency = 1 -- efficiency of 98% (realistic for grid transformers)
	local max_amount = 600 -- stored amount of liquid
	
	for key, struct in pairs(global.transformer_s) do
		--local newbox = {type = "water", amount = 10, temperature = 25}
		--struct.producer.fluidbox[1] = newbox
		local target_amount = 0
		if struct.producer.fluidbox[1] ~= nil then
			target_amount = struct.producer.fluidbox[1].amount
		end
		local source_energy = struct.consumer.energy				-- max energy taken from the source
		local target_energy = (max_amount - target_amount) * eff * 1e4 / efficiency --  energy stored in liquid (1e5 = 6MW)
		local energy_to_move									--1e4(from converson)(for 10 degree temp diff)
		if source_energy > target_energy then
			energy_to_move = target_energy
		else
			energy_to_move = source_energy
		end

		if struct.lastdraw == nil then
			struct.lastdraw = 0
		end
		if energy_to_move > struct.lastdraw then
			energy_to_move = energy_to_move * 0.05 + 0.95 * struct.lastdraw
		end
		--entity.print(tostring(source_energy).." and "..tostring(target_amount))
		--energy_to_move = 0

		struct.lastdraw = energy_to_move	



		if energy_to_move ~= 0 then
			local liquid_amount = energy_to_move / eff / 1e4  -- 1e4 for conversion and rest for eff>1 energy_to_move / 10.0 / 1e5
			--the eff in energy_to_move and liquid_amount are not for same reason.in etm it gives power(kw), in lq-am it gives stored energy(MJ)
			--if target_amount ~= 0 then
			--	entity.print(target_amount)
			--end
			-- 1 lq == 600kw  100etm ==6kw  lq / (100*100)=etm  energy to move at efficiency at 1
			local new_amount = target_amount + liquid_amount * efficiency 
			if new_amount > max_amount then
				new_amount = max_amount -- if rounding gone wrong
			end
			struct.producer.fluidbox[1] = {type="water", amount=new_amount, temperature=25}
			struct.consumer.energy = struct.consumer.energy - energy_to_move 
		end


	end
	end
end
	
function exchanger_m()
	if global.transformer_m ~= nil then

	local eff = 1e2		-- producer efficiency
	local efficiency = 1 -- efficiency of 98% (realistic for grid transformers)
	local max_amount = 6000 -- stored amount of liquid
	
	for key, struct in pairs(global.transformer_m) do
		--local newbox = {type = "water", amount = 10, temperature = 25}
		--struct.producer.fluidbox[1] = newbox
		local target_amount = 0
		if struct.producer.fluidbox[1] ~= nil then
			target_amount = struct.producer.fluidbox[1].amount
		end
		local source_energy = struct.consumer.energy				-- max energy taken from the source
		local target_energy = (max_amount - target_amount) * eff * 1e4 / efficiency --  energy stored in liquid (1e5 = 6MW)
		local energy_to_move									--1e4(from converson)(for 10 degree temp diff)
		if source_energy > target_energy then
			energy_to_move = target_energy
		else
			energy_to_move = source_energy
		end

		if struct.lastdraw == nil then
			struct.lastdraw = 0
		end
		if energy_to_move > struct.lastdraw then
			energy_to_move = energy_to_move * 0.05 + 0.95 * struct.lastdraw
		end
		--entity.print(tostring(source_energy).." and "..tostring(target_amount))
		--energy_to_move = 0

		struct.lastdraw = energy_to_move	



		if energy_to_move ~= 0 then
			local liquid_amount = energy_to_move / eff / 1e4  -- 1e4 for conversion and rest for eff>1 energy_to_move / 10.0 / 1e5
			--the eff in energy_to_move and liquid_amount are not for same reason.in etm it gives power(kw), in lq-am it gives stored energy(MJ)
			--if target_amount ~= 0 then
			--	entity.print(target_amount)
			--end
			-- 1 lq == 600kw  100etm ==6kw  lq / (100*100)=etm  energy to move at efficiency at 1
			local new_amount = target_amount + liquid_amount * efficiency 
			if new_amount > max_amount then
				new_amount = max_amount -- if rounding gone wrong
			end
			struct.producer.fluidbox[1] = {type="water", amount=new_amount, temperature=25}
			struct.consumer.energy = struct.consumer.energy - energy_to_move 
		end

	
	end
	end
end
	
function exchanger_l()
	if global.transformer_l ~= nil then
	
	local eff = 1e3		-- producer efficiency
	local efficiency = 1 -- efficiency of 98% (realistic for grid transformers)
	local max_amount = 6000 -- stored amount of liquid
	
	for key, struct in pairs(global.transformer_l) do
		--local newbox = {type = "water", amount = 10, temperature = 25}
		--struct.producer.fluidbox[1] = newbox
		local target_amount = 0
		if struct.producer.fluidbox[1] ~= nil then
			target_amount = struct.producer.fluidbox[1].amount
		end
		local source_energy = struct.consumer.energy				-- max energy taken from the source
		local target_energy = (max_amount - target_amount) * eff * 1e4 / efficiency --  energy stored in liquid (1e5 = 6MW)
		local energy_to_move									--1e4(from converson)(for 10 degree temp diff)
		if source_energy > target_energy then
			energy_to_move = target_energy
		else
			energy_to_move = source_energy
		end

		if struct.lastdraw == nil then
			struct.lastdraw = 0
		end
		if energy_to_move > struct.lastdraw then
			energy_to_move = energy_to_move * 0.05 + 0.95 * struct.lastdraw
		end
		--entity.print(tostring(source_energy).." and "..tostring(target_amount))
		--energy_to_move = 0

		struct.lastdraw = energy_to_move	



		if energy_to_move ~= 0 then
			local liquid_amount = energy_to_move / eff / 1e4  -- 1e4 for conversion and rest for eff>1 energy_to_move / 10.0 / 1e5
			--the eff in energy_to_move and liquid_amount are not for same reason.in etm it gives power(kw), in lq-am it gives stored energy(MJ)
			--if target_amount ~= 0 then
			--	entity.print(target_amount)
			--end
			-- 1 lq == 600kw  100etm ==6kw  lq / (100*100)=etm  energy to move at efficiency at 1
			local new_amount = target_amount + liquid_amount * efficiency 
			if new_amount > max_amount then
				new_amount = max_amount -- if rounding gone wrong
			end
			struct.producer.fluidbox[1] = {type="water", amount=new_amount, temperature=25}
			struct.consumer.energy = struct.consumer.energy - energy_to_move 
		end


	end
	end
end
	
	
function exchanger_xl()
	if global.transformer_xl ~= nil then
	
	local eff = 1e4		-- producer efficiency
	local efficiency = 1 -- efficiency of 98% (realistic for grid transformers)
	local max_amount = 3000 -- stored amount of liquid
	
	for key, struct in pairs(global.transformer_xl) do
		--local newbox = {type = "water", amount = 10, temperature = 25}
		--struct.producer.fluidbox[1] = newbox
		local target_amount = 0
		if struct.producer.fluidbox[1] ~= nil then
			target_amount = struct.producer.fluidbox[1].amount
		end
		local source_energy = struct.consumer.energy				-- max energy taken from the source
		local target_energy = (max_amount - target_amount) * eff * 1e4 / efficiency --  energy stored in liquid (1e5 = 6MW)
		local energy_to_move									--1e4(from converson)(for 10 degree temp diff)
		if source_energy > target_energy then
			energy_to_move = target_energy
		else
			energy_to_move = source_energy
		end

		if struct.lastdraw == nil then
			struct.lastdraw = 0
		end
		if energy_to_move > struct.lastdraw then
			energy_to_move = energy_to_move * 0.05 + 0.95 * struct.lastdraw
		end
		--entity.print(tostring(source_energy).." and "..tostring(target_amount))
		--energy_to_move = 0

		struct.lastdraw = energy_to_move	



		if energy_to_move ~= 0 then
			local liquid_amount = energy_to_move / eff / 1e4  -- 1e4 for conversion and rest for eff>1 energy_to_move / 10.0 / 1e5
			--the eff in energy_to_move and liquid_amount are not for same reason.in etm it gives power(kw), in lq-am it gives stored energy(MJ)
			--if target_amount ~= 0 then
			--	entity.print(target_amount)
			--end
			-- 1 lq == 600kw  100etm ==6kw  lq / (100*100)=etm  energy to move at efficiency at 1
			local new_amount = target_amount + liquid_amount * efficiency 
			if new_amount > max_amount then
				new_amount = max_amount -- if rounding gone wrong
			end
			struct.producer.fluidbox[1] = {type="water", amount=new_amount, temperature=25}
			struct.consumer.energy = struct.consumer.energy - energy_to_move 
		end


	end
	end
end

	
	
	